function [Aadj,dtA] = adj(A)
%ADJ   Adjoint of 2-D polynomial matrix

As = A.s; As1 = As(1); As2 = As(2);
if As1~=As2,
   error('Matrix is not square.');
end;

no = nargout;
if As1==0,
   Aadj = A;
   if no==2, dtA = pol2(1);
   end;
elseif As1==1,
   Aadj = pol2(1);
   if no==2, dtA = A;
   end;
elseif As1==2,
   Aadjc = A.c;
   Aadjc(1,2,:,:) = -Aadjc(1,2,:,:);
   Aadjc(2,1,:,:) = -Aadjc(2,1,:,:);
   pom = Aadjc(1,1,:,:);
   Aadjc(1,1,:,:) = Aadjc(2,2,:,:);
   Aadjc(2,2,:,:) = pom;
   Aadj = pol2(Aadjc);
   if no==2,
      Ac11 = pol2(Ac(1,1,:,:));
      Ac12 = pol2(Ac(1,2,:,:));
      Ac21 = pol2(Ac(2,1,:,:));
      Ac22 = pol2(Ac(2,2,:,:));
      dtA = Ac11*Ac22 - Ac12*Ac21;
   end;
else
   Aadj=pol2(adj(pol2sp(A)));
   if no==2,
       dtA=pol2(det(pol2sp(A)));
   end;
end;

%end .. @pol2/adj
