function [A,C] = declass(P)
%DECLASS  Declass 2-D polynomial (convert to possible lower class)
%            A = DECLASS(P)
%
% The command
%     A = DECLASS(P)
% declasses a 2-D polynomial matrix P, i.e. changes its class to double
% (standard Matlab matrix) if possible (if it is empty or constant 2-D
% polynomial matrix).
%
% The command
%     [A,C] = DECLASS(P)
% returns also the resulting class in C.

Pd = P.d;
if isempty(Pd) | any(Pd<0),
   A = zeros(P.s(1),P.s(2));
elseif all(Pd==0),
   A = P.c(:,:,1,1);
else
   A = P;
end;
C = class(A);

%end .. @pol2/declass
