function A = double(P)
%DOUBLE  Convert 2-D polynomial to double (standard Matlab matrix)
%             A = DOUBLE(P)
%
% The command
%     A = DOUBLE(P)
% converts a 2-D polynomial matrix P to double (standard MATLAB matrix)
% if possible (if it is empty or constant 2-D polynomial matrix).
% If not possible, error.
%
Pd = P.d;
if isempty(Pd) | any(Pd<0),
   A = zeros(P.s(1),P.s(2));
elseif all(Pd==0),
   A = P.c(:,:,1,1);
else
   error('Argument is not convertible to double.');
end;

%end .. @pol2/double
