function [Ai,Ar] = imag(A);
%IMAG  Imaginary part of 2-D polynomial
%
% IMAG(A) is the imaginary part of A.
% [AI,AR] = IMAG(A) returns also the real part.
%
% See also POL2/REAL.

Ai = A;
Ai.c = imag(A.c);
Ai = pclear(Ai);

if nargout==2,
   Ar = A;
   Ar.c = real(A.c);
   Ar = pclear(Ar);
end;

%end .. @pol2/imag

