function C = mtimes(A,B,met);
%MTIMES (*)  Matrix multiply of 2-D polynomials
%           C = A*B

if nargin<2,
   error('Not enough input arguments.');
end;
if nargin==3,
   if ~isa(met,'char'),
      error('Invalid 3rd argument.');
   end;
else met = 'def';
end;

eval('A = pol2(A);','error(''Invalid 1st argument.'');');
eval('B = pol2(B);','error(''Invalid 2nd argument.'');');
[rA,cA] = size(A);
[rB,cB] = size(B);
if all([rA,cA]==[1,1]) | all([rB,cB]==[1,1]), %one or both are 1-by-1 matrices
   eval('C = times(A,B,met);','error(peel(lasterr));');
   C = pol2(C);
   return;
end;

if cA~=rB,
   error('Matrices of inconsistent dimensions.');
end;
if rA==0 | cA==0 | cB==0,
   C = zeros(rA,cB); return;
end;

switch met,
case 'def',
   if all([A.d,B.d]==[0,0,0,0]), % multiplication of constant metrices
       C=squeeze(A.c)*squeeze(B.c);   
   else
       Cd=A.d+B.d;
       C1=sylv(A,B.d+[1,1],['x','y'],'col')*sylv(B,[1,1],['x','y'],'col');
       C1=permute(C1,[2 1 3 4]); %!!!!!!!!!!!!!!
       C1=reshape(C1,[rA,cB,Cd(1)+1,Cd(2)+1]);
       C=permute(C1,[2 1 3 4]); %!!!!!!!!!!!!!! 
   end; %
   C=pol2(C);
   C=pzer(C);
   
case 'fft',
   Asp = pol2sp(A); Bsp = pol2sp(B);
   Csp = Asp*Bsp; C = pol2(Csp);
   
otherwise
   error('Invalid command option.');
end;

%end .. @pol2/mtimes
