function X=pad(Y,deg_xy);
% Function 
% X=PAD(Y,[deg_x,deg_y])
% pad the 2-D polynomial matrix to required
% degree with 0 (zeros) in both variables.
% 
% Y - 2-D polynmomial matrix we want to pad
% 
% [deg_x,deg_y] - vector of reguired degrees in both variables

Ys=size(Y);
Yd=Y.d;
if (Yd(1))>deg_xy(1),
    error('Required padded degree of variable x is less than the current one.');
end;
if (Yd(2))>deg_xy(2),
    error('Required padded degree of variable y is less than the current one.');
end;
%-------------
X.d=deg_xy;
X.s=Ys;
X.c=zeros(Ys(1),Ys(2),deg_xy(1),deg_xy(2));
X.c(:,:,Yd(1)+1,Yd(2)+1)=Y;
X.v = ['x','y'];
X.u = [];
%-------------

X = class(X,'pol2');



