function Pshift = shift(P,n,m);
%SHIFT   Shift 2-D  polynomial
%
%
na = nargin;
if na==3,
   if ~isa(n,'double') | ndims(n)>2 | ~isreal(n) | ...
         (~isempty(n) & any(any(floor(n)~=n)) ),
      error('Invalid 2nd argument; must be integer.');
   end;
   if ~isa(m,'double') | ndims(m)>2 | ~isreal(m) | ...
         (~isempty(m) & any(any(floor(m)~=m)) ),
      error('Invalid 3rd argument; must be integer.');
   end;   
elseif na==2,
   if ~isa(n,'double') | ndims(n)>2 | length(n)~=2 | ...
         ~isreal(n) | any(any(floor(n)~=n)),
      error('Invalid 2nd argument or missing 3rd one.');
   end;
   m = n(2); n = n(1);
else
   error('Not enough input arguments.');
end;

eval('P = pol2(P);', 'error(peel(lasterr));');
ns = size(n); Ps = P.s;
if all(ns==1),           % n  is scalar
   if any(Ps~=1),                  % P  is matrix
      n = ones(Ps)*n;
   end;
else                     % n  is matrix
   if all(Ps==1),                  % P  is scalar
      P = ones(ns)*P; Ps = P.s;
   else                            % P  is matrix
      if any(Ps~=ns),
         error('Matrices not of the same dimensions.');
      end;
   end;
end;

ms = size(m);
if all(ms==1),
   if any(Ps~=1),
      m = ones(Ps)*m;
   end;
else
   if all(Ps==1),
      P = ones(ms)*P; Ps = P.s;
      n = ones(ms)*n;
   else
      if any(Ps~=ms),
         error('Matrices not of the same dimensions.');
      end;
   end;
end;

if isempty(P.c),
   Pshift = P; return;
end;

nmin = min(min(n)); nmax = max(max(n));
mmin = min(min(n)); mmax = max(max(m));
Psd = P.d + [nmax,mmax];
if any(Psd<0),
   error('Shifting to negative powers.');
end;
Pshift.d = Psd;
Pshift.s = Ps;
pom = zeros(Ps(1),Ps(2),Psd(1)+1,Psd(2)+1);
Pshift.c = pom;
Pshift.v = 'xy';
Pshift.u = [];

Pd1plus1 = P.d(1)+1; Pd2plus1 = P.d(2)+1;
for i = 1:Ps(1);
   for j = 1:Ps(2);
      nij = n(i,j);
      if nij>=0,
         pom(i,j,1+nij:Pd1plus1+nij,1:Pd2plus1) = ...
            P.c(i,j,1:Pd1plus1,1:Pd2plus1);
      else   
         if ~isempty(nonzeros(P.c(i,j,1:min(abs(nij),Pd1plus1),1:Pd2plus1))),
            error('Shift to negative powers.');
         end;
         pom(i,j,1:Pd1plus1+nij,1:Pd2plus1) = ...,
            P.c(i,j,1-nij:Pd1plus1,1:Pd2plus1);
      end;
      pomdplus1 = Pd1plus1+nij;
      mij = m(i,j);
      if mij>=0,
         Pshift.c(i,j,1:pomdplus1,1+mij:Pd2plus1+mij) = ...
            pom(i,j,1:pomdplus1,1:Pd2plus1);
      else
         if ~isempty(nonzeros(P.c(i,j,1:Pd1plus1,1:min(abs(mij),Pd2plus1)))),
            error('Shift to negative powers.');
         end;
         Pshift.c(i,j,1:pomdplus1,1:Pd2plus1+mij) = ...
            pom(i,j,1:pomdplus1,1-mij:Pd2plus1);
      end;
   end;
end;

Pshift = class(Pshift,'pol2');
Pshift = pclear(Pshift);

%end .. @pol2/pshift
