function C = times(a,b,met);
% The function
% C=TIMES(A,B) or
% C=A.*B
% compute element-by-element
% multiplication of 
% POL2 matrices

if nargin<2,
   error('Not enough input arguments.');
end;
if nargin==3,
   if ~isa(met,'char'),
      error('Invalid 3rd argument.');
   end;
else met = 'def';
end;

eval('a = pol2(a);','error(''Invalid 1st argument.'');');
eval('b = pol2(b);','error(''Invalid 2nd argument.'');');
%[td,a,b] = testdp(a,b);
%if td==0,
%   error('Matrices not of the same dimensions.');
%end;

switch met,
case 'def',
   [ra,ca] = size(a);
   da=a.d; db=b.d;
   if isempty(da),
      dc = []; nc1 = 0; nc2 = 0;
   else
      dc = da+db;                       % J.Jezek
      if any(dc<0),                     %
         nc1 = 0; nc2 = 0;              %
      else                              %
         nc1 = dc(1)+1; nc2 = dc(2)+1;  %
      end;                              %
   end;
   c.d = dc;  % separate degree entry for each variable
   c.s = [ra,ca]; % size of matrix
   c.c = zeros(ra,ca,nc1,nc2); % 
   c.v = ['x','y'];
   c.u = [];   % J.Jezek

   if ~isempty(dc) & ~any(dc<0),    % J.Jezek
      for i=0:dc(1),
         %a
         dmezax=max(0,i-db(1));
         hmezax=min(i,da(1));
         %b
         dmezbx=i-hmezax;
         hmezbx=i-dmezax;
         for j=0:dc(2),
            dmezay=max(0,j-db(2));
            hmezay=min(j,da(2));
            
            dmezby=j-hmezay;
            hmezby=j-dmezay;
            
            %c{i}=sum(a{dmeza:hmeza}.*b{hmezb:-1:dmezb});
            c.c(:,:,i+1,j+1)=sum(sum(a.c(:,:,(dmezax+1):(hmezax+1),(dmezay+1):(hmezay+1))...
                .*b.c(:,:,(hmezbx+1):-1:(dmezbx+1),(hmezby+1):-1:(dmezby+1)),3),4);
            
            %c.c(1,1,i+1,j+1)=sum(sum(a.c(1,1,(dmezax+1):(hmezax+1),(dmezay+1):(hmezay+1))...
            %    .*b.c(1,1,(hmezbx+1):-1:(dmezbx+1),(hmezby+1):-1:(dmezby+1))));
         end;
      end;
   end;

   C = class(c,'pol2');
   C = pzer(C);
   
case 'fft',
   asp = pol2sp(a); bsp = pol2sp(b);
   csp = times(asp,bsp); C = pol2(csp);
   
otherwise
   error('Invalid command option.');
end;
   
%end .. @pol2/times
