function Al = tril(A,k);
%TRIU  Upper triangular part  of 2-D polynomial

if nargin==2,
   if ~isnumeric(k) | any(size(k)>1),
      error('Invalid argument; must be numeric scalar.');
   end;
   if isempty(k),
      Al = pol2([]); return;
   end;
else k = 0;
end;

if isempty(A.d),
   Al = A; return;
end;

Al.d = A.d;
Al.s = A.s;
Ac = A.c;
Alc = zeros(size(A.c));
An1 = A.d(1)+1; An2 = A.d(2)+1;
if An1>0 & An2>0,
   for i = 1:An1,
      for j = 1:An2,
         Alc(:,:,i,j) = triu(Ac(:,:,i,j),k);
      end;
   end;
end;
Al.c = Alc;
Al.v = A.v;
Al.u = [];

Al = class(Al,'pol2');
Al = pclear(Al);

%end .. @pol2/triu
