function [C,D]=adj(M);
% adjoint matrix
% POL2SP matrix






Ms=size(M);

if (Ms(1)~=Ms(2)),
    error('Matrix is not square.')
end;

    Nsp=2.^(ceil(log2((Ms(1)-1).*M.d+[1,1])));

    M=msl(M,Nsp);
    
    C.d = (Ms(1)-1).*M.d;  % separate degree entry for each variable
    C.n = Nsp;  % number of used spectra-points
    C.s = [1,1]; % size of matrix
    C.c = zeros([1,1,C.n]); 
    C.v = ['x','y'];
    C.u = [];
    C.k = M.k;

    
    for pos_x=1:Nsp(1),
        for pos_y=1:Nsp(2),
            C.c(1,1,pos_x,pos_y)=adj(M.c(:,:,pos_x,pos_y));
        end;
    end;

    C=class(C,'pol2sp');

    
    if nargout==2,
        D=det(M);
    end;
    