function [N,Nsp_aux]=mrr(M,par);

% Function
% [N,Nsp_aux]=mrr(M,par) extract or enlarge the spectra array
%  
%  par - 'halve' - for real coefficients and spectra
%                  over 8 points count number of 
%                  sufficient points -> Nsp_aux
%          'pad' - use the first half of spectra
%                  for encounting of the second part
%                  the input matrix which has to be extracted or enlarged
%                  
%   M - input matrix which has to be extracted or enlarged          
%                 
%   Nsp_aux - final number of spectra points - a 1x2 vector
%             [x,y] - points in variable x and y
%             
%   N - output matrix          


if ~M.k % complex coefficients
    N=M;
    Nsp_aux=M.n;
    
else % real cofficients
    if par=='halve',
        N=M;
        if all(M.n>=[8,8]),
            Nsp_aux=floor(1.*(M.n)/2)+[1,1];
            N.c(:,:,Nsp_aux(1)+1:M.n(1);
        end;
        

        
        
    
    if C.k % clever trick - for real coefficients work with 1/2 of spectra
        Nsp_aux=[0,0];
%         if Nsp(1)>=8,
%             Nsp_aux(1)=Nsp(1)/2+1;
%         else,
%             Nsp_aux(1)=Nsp(1);
%         end;
        
        if Nsp(2)>=8,
            Nsp_aux(2)=Nsp(2)/2+1;
        else,
            Nsp_aux(2)=Nsp(1);
        end;
        
        for pos_x=1:Nsp(1),
            for pos_y=1:Nsp_aux(2),
                C.c(:,:,pos_x,pos_y)=A.c(:,:,pos_x,pos_y)*B.c(:,:,pos_x,pos_y);
            end;
        end;
        % morroring 
        if Nsp_aux(2)<Nsp(2),
            C.c(:,:,:,Nsp_aux(2)+1:Nsp(2))=C.c(:,:,:,2:Nsp_aux(2)-1);
        end;
