function B=repmat(A,M,N);
%  REPMAT Replicate  an POL2SP matrix.
%    B = repmat(A,M,N) creates a large matrix B consisting of an M-by-N
%    tiling of copies of A. 

if nargin~=3,
   error('Not enough input arguments.');
end;

A=pol2sp(A);

if ~isa(M,'double') | length(M)~=1 | ~isreal(M) | any(M<0) | any(floor(M)~=M),
   error('Invalid 2nd argument.');
elseif ~isa(N,'double') | length(N)~=1 | ~isreal(N) | any(N<0) | any(floor(N)~=N),
   error('Invalid 3nd argument.');
end;

B.d = A.d;
B.n = A.n;
B.s = A.s.*[M,N]; % size of matrix
B.c = zeros([B.s,B.n]);
B.v = ['x','y'];
B.u = [];
B.k = A.k;

B.c = repmat(A.c,M,N);

B = class(B,'pol2sp');