function B = inv(A)
%INV    Inversion of two-sided 2-D polynomial

As = A.s; As1 = As(1); As2 = As(2);
if As1~=As2,
   error('Matrix is not square.');
end;

if As1==0,
   B = A; return;
end;

Ap = A.p;
[Apadj,Apdet] = adj(Ap);
Apdetd = Apdet.d;
if any(Apdetd<0),
   error('Matrix is singular.');
end;
Apdetd1 = Apdetd(1); Apdetd2 = Apdetd(2);
Apdetc = zeros(Apdetd1+1,Apdetd2+1);
Apdetc(:,:) = Apdet.c(1,1,1:Apdetd1+1,1:Apdetd2+1);
[kk,ll] = find(Apdetc);
if length(kk)~=1,
   error('Argument is not invertible.');
end;
B = tsp2((1/Apdetc(kk,ll))*Apadj);
B = shift(B,-A.o-[Apdetd1,Apdetd2]);

%end .. @tsp2/inv
