function B = power(A,n)
%POWER   Element-wise power of two-sided 2-D polynomial

na = nargin;
if na==2,
   if ~isa(n,'double') | ndims(n)>2 | ~isreal(n) | ...
         any(any(floor(n)~=n)),
      error('Invalid 2nd argument; must be integer.');
   end;
else
   error('Not enough input arguments.');
end;

if ~all(size(A)==size(n)),
   if all(size(A)==1),
      A = repmat(A,size(n));
   elseif all(size(n)==1),
      n = repmat(n,size(A));
   else
      error('Matrices not of the same dimensions.');
   end;
end;

Ap = A.p;
if all(all(n>=0)),
   BB = 0;
   eval('BB = power(Ap,n);','error(peel(lasterr));');
   B = tsp2(BB);
else
   As = A.s; As1 = As(1); As2 = As(2);
   Apo1 = zeros(As1,As2); Apo2 = Apo1;
   m = n;
   for i = 1:As1;
      for j = 1:As2;
         Apij = Ap(i,j); mij = m(i,j);
         if mij<0,
            Apijd = Apij.d;
            if any(Apijd<0),
               error('Zero element powered to negative power.');
            end;
            Apijd1 = Apijd(1); Apijd2 = Apijd(2);
            Apc = zeros(Apijd1+1,Apijd2+1);
            Apc(:,:) = Apij.c(1,1,1:Apijd1+1,1:Apijd2+1);
            [kk,ll] = find(Apc);
            if length(kk)~=1,           
               error('Invalid argument; cannot be powered to negative power.');
            end;
            Ap(i,j) = 1/Apc(kk,ll);
            absmij = abs(mij);
            Apo1(i,j) = -Apijd1*absmij; Apo2(i,j) = -Apijd2*absmij;
            m(i,j) = absmij;
         end;
      end;
   end;
   BB = power(Ap,m); 
   B = tsp2(BB); B = shift(B,Apo1,Apo2);
end;
B = shift(B,n*A.o(1),n*A.o(2));

%end .. @tsp2/power
