function P=see(m);

%function SEE assemble a picture of a 2-D Two Sided Polynomial scalar.
% 
% example
% SEE(b) - return a figure with grafical representation of 
% the given two-sided 2-D polynomial b (class TSP2)
% - all complex values of polynomial coefficiets are representet as
%   ABS values to be able to show it - in this case the color of the value is
%   red
% - null values colored transparent yellow
% - real values are blue

% fast check
 if ~isa(m,'tsp2'),
     error('Wrong argument class. TSP2 needed.');
 elseif ~((m.s(1)==1)&(m.s(2)==1));
     error('Just scalars are pictured')
 end;
 
%H_fig=figure;

u_min=m.o(1);
w_min=m.o(2);
u_max=m.o(1)+m.d(1);
w_max=m.o(2)+m.d(2);

vertical_max=max(max(abs(m.p.c)));
% vertical_min=min(min((m.p.c)));
vertical_min=0;

% axis([u_min-1,u_max+1,w_min-1,w_max+1,vertical_min,vertical_max+1]); % 
% vede na obdelnikove obrazky

axis_max=max(abs([u_min , u_max , w_min , w_max]));
% radeji cvtercovou podstavu
axis([-axis_max-1 , axis_max+1 , -axis_max-1 , axis_max+1 , vertical_min , vertical_max+1]);

%campos([0,0,3*vertical_max]);
grid on;
hold on;

% draw border
x_border=[u_min-0.5,u_min-0.5,u_max+0.5,u_max+0.5];
y_border=[w_min-0.5,w_max+0.5,w_max+0.5,w_min-0.5];
z_border=zeros(1,4);
H_border=fill3(x_border,y_border,z_border,'y');
%alpha(H_border,0.1);

%draw zero axis
N=[0,0];
x_spacing=[-axis_max-1,axis_max+1];
y_spacing=[-axis_max-1,axis_max+1];
z_spacing=[vertical_min,vertical_max+1];

H_x_ax=line(x_spacing,N,N); set(H_x_ax,'LineWidth',2,'Color',[0 0.75 1]);
H_y_ax=line(N,y_spacing,N); set(H_y_ax,'LineWidth',2,'Color',[0 0.75 1]);
H_z_ax=line(N,N,z_spacing); set(H_z_ax,'LineWidth',2,'Color',[0 0.75 1]);

text(axis_max+1,0,0,'variable u');
text(0,axis_max+1,0,'variable w');
title('All coefficients are representet as ABS values !!!');

% draw coefficients
n_u=m.d(1)+1;
n_w=m.d(2)+1;

b_m=0.1; % Border_Margin - spacing between two coefficient and border

maximum=max(max(abs(m.p.c(1,1,:,:))));

for U=1:n_u,
    for W=1:n_w,
        U_abs_pos=U-1+m.o(1); % bacha na indexovani
        W_abs_pos=W-1+m.o(2);
        U_spacing=U_abs_pos+[-0.5+b_m , -0.5+b_m , +0.5-b_m , +0.5-b_m];    
        W_spacing=W_abs_pos+[-0.5+b_m , +0.5-b_m , +0.5-b_m , -0.5+b_m];
        % U_spacing=[U_abs_pos-0.5+b_m , U_abs_pos-0.5+b_m , U_abs_pos+0.5-b_m , U_abs_pos+0.5-b_m];    
        % W_spacing=[W_abs_pos-0.5+b_m , W_abs_pos+0.5-b_m , W_abs_pos+0.5-b_m , W_abs_pos-0.5+b_m];
        if m.p.c(1,1,U,W)==0;
            Z_pos=zeros(1,4);
            Hf=fill3(U_spacing,W_spacing,zeros(1,4),'w');
        elseif isreal(m.p.c(1,1,U,W)),
            Z_pos=repmat(abs(m.p.c(1,1,U,W)),1,4);
            Hf=fill3(U_spacing,W_spacing,Z_pos,'c');
            text(U_abs_pos,W_abs_pos,abs(m.p.c(1,1,U,W))+0.1,int2str(m.p.c(1,1,U,W)));
            %text(U_abs_pos,W_abs_pos,0.1,int2str(m.p.c(1,1,U,W)));
        else, % for complex coefficients
            Z_pos=repmat(abs(m.p.c(1,1,U,W)),1,4);
            Hf=fill3(U_spacing,W_spacing,Z_pos,'r');
            text(U_abs_pos,W_abs_pos,abs(m.p.c(1,1,U,W))+0.1,[int2str(real(m.p.c(1,1,U,W))),'+',int2str(imag(m.p.c(1,1,U,W))),'i']);
            %text(U_abs_pos,W_abs_pos,0.1,[int2str(real(m.p.c(1,1,U,W))),'+',int2str(imag(m.p.c(1,1,U,W))),'i']);
        end;
        col=1-(abs(m.p.c(1,1,U,W))/maximum);
        %set(Hf,'FaceColor',[col,col,col]);
    end;
end;

        
%alpha(H_border,0.1);


hold off

