function [s1,s2,s3,s4] = size(T,d)
%SIZE   Size of a two-sided 2-D polynomial matrix

ni = nargin; no = nargout;
if ni==2 & ~isa(d,'double'),
   error('Invalid 2nd argument; must be 1, 2, 3 or 4.');
end;
row = T.s(1);
col = T.s(2);
if ni==1,
   s1 = row; s2 = col;
   if no<2,
      s1 = [row,col];
   elseif no>=3,
      s3 = T.d;
      if no==4,
         if isempty(s3), s4 = [];
         else s4 = s3(2); s3 = s3(1);
         end;
      end;
   end;
elseif no>1,
   error('Too mny output arguments.');
else,
   switch d,
   case 1,
      s1 = row;
   case 2,
      s1 = col;
   case 3,
      s1 = T.d;
      if ~isempty(s1), s1 = s1(1);
      end;
   case 4,
      s1 = T.d;
      if ~isempty(s1), s1 = s1(2);
      end;
   otherwise,
      error('Invalid 2nd argument; must be 1, 2, 3 or 4.');
   end;
end;

%end .. @tsp2/size
      