function T = subsasgn(T,S,R);
%SUBSASGN  Subscripted assignment for two-sided 2-D polynomial

if nargin<3,
   error('Not enough input arguments.');
end;
if ~isstruct(S),
   error('Invalid 2nd argument.');
end;

S_lg = length(S); S1 = S(1);
St1 = S1.type; Ss1 = S1.subs;
Ss1_lg = length(Ss1);

switch St1,
case '.',
   flstr = lower(Ss1); flstr1 = flstr(1);
   switch flstr1,
   case 'u',
      S(1) = [];
      if isempty(S),
         T.u = R;
      else
         Tu = T.u;
         eval('Tu = subsasgn(Tu,S,R);', 'error(peel(lasterr));');
         T.u = Tu;
      end;
      
   otherwise
      error('Invalid field in subscripted assignment.');
   end;
   
case '()',
   Tp = T.p; To = T.o;
   eval('R = tsp2(R);', 'error(peel(lasterr));');
   Rp = R.p; Ro = R.o;
   if Ro(1)>=To(1),
      Rp = shift(Rp,Ro(1)-To(1),0);
   else
      Tp = shift(Tp,To(1)-Ro(1),0);
      To(1) = Ro(1);
   end;
   if Ro(2)>=To(2),
      Rp = shift(Rp,0,Ro(2)-To(2));
   else
      Tp = shift(Tp,0,To(2)-Ro(2));
      To(2) = Ro(2);
   end;
   eval('Tp = subsasgn(Tp,S,Rp);', 'error(peel(lasterr));');
   T = tsp2(Tp); T = shift(T,To);
   if S_lg>1,
      error('Invalid combination in subscripted assignment.');
   end;
   
case '{}',
   error('Not yet implemented.');
   
otherwise
   error('Invalid 2nd argument.');
end;

%end .. @tsp2/subsasgn

   
         