function T = subsref(T,S)
%SUBSREF   Subscripted reference for two-sided 2-D polynomial
%
if nargin<2,
   error('Not enough input arguments.');
end;
if ~isstruct(S),
   error('Invalid 2nd argument.');
end;

Tp = T.p; To = T.o;
S_lg = length(S); S1 = S(1);
St1 = S1.type; Ss1 = S1.subs;
Ss1_lg = length(Ss1);
switch St1,
case '.',
   flstr = lower(Ss1); flstr1 = flstr(1);
   switch flstr1,
   case 'p', T = Tp;
   case 's', T = T.s;
   case 'd', T = T.d;
   case 'o', T = To;
   case 'v', T = T.v;
   case 'u', T = T.u;
   otherwise,
      error('Invalid field in subscripted reference.');
   end;
   
case '()'
   eval('Tp = subsref(Tp,S1);','error(peel(lasterr));');
   T = tsp2(Tp); T = shift(T,To);
   
case '{}',
   if Ss1_lg>2
      error('More than two subscripts in {}.');
   elseif Ss1_lg==2,
      if isa(Ss1{1},'double'),
         S1.subs{1} = Ss1{1}-T.o(1);
      end;
      if isa(Ss1{2},'double'),
         S1.subs{2} = Ss1{2}-T.o(2);
      end;
   elseif Ss1_lg==1,
      if isa(Ss1{1},'double'),
         Td = T.d;
         if ~isempty(Td),
            if Td(2)<=0,
               S1.subs{1} = Ss1{1}-T.o(1);
            elseif Td(2)<=0,
               S1.subs{2} = Ss1{2}-T.o(2);
            else
               error('Two subscripts in {} needed.');
            end;
         end;
      end;
   end;
   eval('T = subsref(Tp,S1);','error(peel(lasterr));');
%   T = tsp2(Tp); T = shift(T,To);   
    
otherwise
   error('Invalid 2nd argument.');
end;

S(1) = [];
if ~isempty(S),
   eval('T = subsref(T,S);', ...
      ['if isa(T,''pol2'') | isa(T,''tsp2''),', ...
      'error(peel(lasterr)); else error(peelf(lasterr)); end;']);   
end;
   
%end .. @tsp2/subsref
