function T = tsp2(arg)
%TSP2   Create two-sided 2-D polynomial
%
% The internal structure:
%
% T.p   POL2 object shifted to positive powers of X and Y
% T.s   size
% T.d   degrees
% T.o   offsets, i.e. the powers of X and Y to obtain T.p
%                     from the original
% T.v   variable symbols, always ['u','w']
% T.u   user data

na = nargin;
if na==1 & isa(arg,'tsp2'),  % quick exit
   T = arg; return;
end;

if na==0, arg = [];
end;
eval('arg = pol2(arg);','error(''Invalid argument.'');');
[nrow,ncol] = size(arg);

T.p = arg;
T.s = [nrow,ncol];
T.d = arg.d;
T.o = [0,0];
T.v = 'uw';
T.u = [];

superiorto('double','pol2');
T = class(T,'tsp2');
T = tclear(T);

%end .. @tsp2/tsp2
