function T2sp = tsp2sp(varargin)
%TSP2SP   Create spectra of two-sided 2-D polynomial 
%
% The internal structure:
%
% T.p   POL2SP object shifted to positive powers of X and Y 
% T.s   size
% T.d   degrees
% T.n   [nu,nw] - numbers of spectral points
% T.o   offsets, i.e. the powers of X and Y to obtain T.p
%                     form the original
% T.v   variable symbols, always ['u','w']
% T.u   user data


if nargin==0,
    arg = [];
    
elseif nargin==1, %just a TSP2/TSP2SP object as argument
    % kontrola
    if isa(varargin{1},'tsp2sp'),
        T2sp=varargin{1};
        return;
    elseif ~isa(varargin{1},'tsp2'),
        error('Wrong argument class.');
    end;
    %----------
    T2=varargin{1};
    Nsp=2.^(ceil(log2(T2.d+[1,1]))); % minimal number of points
    
elseif nargin==2,  % with required number of points
    % kontrola
    if isa(varargin{1},'tsp2sp'),
        T2sp=varargin{1};
        return;
    elseif ~isa(varargin{1},'tsp2'),
        error('Wrong argument class.');
    end;
    %----------
    T2=tsp2(varargin{1});
    Nsp_opt=2.^(ceil(log2(t2.d+[1,1])));
    if isempty(varargin{2}), % check explicite number of spectra points
        Nsp=Nsp_opt; 
    elseif size(varargin{2})~=[1,2],
        error('Wrong size of 2nd argument. It has to be a 1x2 positive integer vector.');
    elseif any(varargin{2}<Nsp_opt);
        Nsp=Nsp_opt;
    else
        Nsp=varargin{2};
    end;
else
    error('Bad argument syntax.')
end;



T2sp.p=pol2sp(varargin{1}.p);
T2sp.s=varargin{1}.s;
T2sp.d=varargin{1}.d;
T2sp.n=Nsp;
T2sp.o=varargin{1}.o; 
T2sp.v=varargin{1}.v;   
T2sp.u=  '';

%nahrada vypisu - prozatim
T2sp

T2sp=class(T2sp,'tsp2sp');

