function G = derivs(F,varargin)
%DERIVS    Derivatives of constant
%
if nargin==0,
   error('Not enough input arguments.');
end;
if ~isa(F,'double') | ndims(F)>2,
   error('Invalid 1st argument.');
end;

n = []; allder = 0; err = 0;
li = length(varargin);
if li>0,
   for i = 1:li,
      arg = varargin{i};
      if isa(arg,'double') & length(arg)==1 & isreal(arg)& arg>=0,
         if floor(arg)==arg,
            if isempty(n), n = arg;
            else err = 1;
            end;
         elseif arg<=1,   %  tol ignored
         else err = 1;
         end;
      elseif isa(arg,'char'),
         if strcmp(arg,'all'), allder = 1;
         else var = arg;
         end;
      end;
      if err,
         text = ['Invalid ',nth(i+1),' argument.'];
         error(text);
      end;
   end;
end;
if isempty(n), n = 1;
end;

G = cell(1,n+1);
if ~allder,
   if n==0, G{1} = F;
   else G(:) = {zeros(size(F))};
   end;
else
   G{1} = {F};
   if n>0,
      for i = 2:n+1,
         H = cell(1,i);
         H(:) = {zeros(size(F))};
         G{i} = H;
      end;
   end;
end;

%end .. derivs
