function Z = mvalue(F,X,Y)
%MVALUE     Matrix value of constant
%
% For constant F (i.e. standard Matlab matrix),
% the command  Y = MVALUE(F,X,Y)  returns F or
% F*eye matrix of dimension of X or Y. Arguments
% X,Y plays no role but they must be constant
% scalars. One of them may be also square matrix.
% They may be also omitted.
%
% This macro exists only for completeness.
% See also POL2/MVALUE.

ni = nargin;
if ni<1,
   error('Not enough input arguments.');
end;
if ~isa(F,'double') | ndims(F)>2,
   error('Invalid 1st argument.');
end;

if ni==3,
   eval('Z = mvalue(pol2(F),X,Y);','error(peel(lasterr));');
elseif ni==2,
   eval('Z = mvalue(pol2(F),X);','error(peel(lasterr));');
else
   eval('Z = mvalue(pol2(F));','error(peel(lasterr));');
end;

%end .. mvalue
